<id>
Ignore User Posts
</id>

<version>
1.0
</version>

<mod info>
Description:
This mod allows each user to ignore the blatant post of other regged users for a while.

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

YaBB.pl (ASCII)
AdminIndex.pl (ASCII)
Admin/AdminSubList.pl (ASCII)
Admin/ModList.pl (ASCII)
Languages/English/Admin.lng (ASCII)
Languages/English/Display.lng (ASCII)
Languages/English/Menu.lng (ASCII)
Sources/Display.pl (ASCII)
Sources/Post.pl (ASCII)
Sources/Profile.pl (ASCII)
Sources/Recent.pl (ASCII)
Sources/Search.pl (ASCII)
Sources/SubList.pl (ASCII)
Sources/YaBBC.pl (ASCII)
Templates/default/Display.Template (ASCII)
Variables/Menu0.def (ASCII)
Variables/Menu1.def (ASCII)
Variables/Menu2.def (ASCII)
</mod info>

<author>
original by Ron Spikecity, expanded by  Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>

<homepage>
http://yabb.xost.ru/ and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'removeoldthreads',"RemoveOldTopics.pl&RemoveOldThreads",
</search for>

<add after>
'editignore',"IgnoreUser.pl&EditIgnore",
'editignore2',"IgnoreUser.pl&EditIgnore2",
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$IgnoreUser = "Ignore User|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a> and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">Jet Li</a>)|This mod allows each user to ignore the blatant post of other regged users for a while.<br /><br/></span><span class=\"small\"><b>Credits:</b> original mod idea (YaBB 1.3.1) by Ron Spikecity</span>|1.0|05.02.2007";
	push (@installed_mods, "$IgnoreUser");
</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
&LoadIMs;     # Load IM's
</search for>

<add after>
if (-e("$memberdir/$username.ign") && !$staff && !$iamadmin && !$iamgmod) {
      fopen (FILEMYIGN, "$memberdir/$username.ign");
      @myignorelist = <FILEMYIGN>;
      fclose (FILEMYIGN);
      $myignorecnt = @myignorelist;
      if ($myignorecnt > 0) {
            fopen(FILEIGN, "$langdir/$language/ignore.txt") || &fatal_error("cannot_open","$langdir/$language/ignore.txt", 1);
            @ignoretxt = <FILEIGN>;
            fclose(FILEIGN);
            $ignoretxt = join("",@ignoretxt);
      }
}
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$IgnoreUser = "editignore|Ignore User|Ignore User|";
push (@boardmod_mods, "$IgnoreUser");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
%mod_list=(
'1' => "Name",
'2' => "Author",
'3' => "Release Date",
'4' => "Version",
'5' => "All Installed Mods",
'6' => "Installed Mods",
'7' => "View a list of all Installed Mods",
'8' => "No mods are currently installed. You can get new mods at",
'9' => "BoardMod",
);

</search for>

<add after>
%igntxt=(
'1' => "Ignore User Post Settings",
'1a' => "This text will replace the original messages from a blocked user.<br />YaBBC tags NO allowed in it",
'4' => "Save Ignore User Text",
);

</add after>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
$display_polltxt{'2a'} = "Add Poll";
</search for>

<add before>
%igntxt=(
'2' => "Ignore all posts from this User?",
'3' => "Un-Ignore all posts from this User?",
'5' => "You are not allowed to Ignore a Staff Member!"
);

</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
'627' => "Mark as Unread",
</search for>

<add after>
'ignore' => "Ignore",
'unignore' => "Un-Ignore",
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		$message = $postmessage;
</search for>

<replace>
            $ignoreuser = '';
            if ($myignorecnt > 0) {
                  foreach (@myignorelist) {
                        chomp($_);
                        if ($musername eq $_ ) { $ignoreuser = 1; last; }
                  }
            }
            $template_ignore = '';
            $postfrommod = '';
            $postfrommod = &is_moderator($musername);
                if ($username ne $musername && ${$uid.$musername}{'position'} ne "Administrator" && ${$uid.$musername}{'position'} ne "Global Moderator" && !$iamadmin && !$iamgmod && !$iammod && !$postfrommod && !$iamguest && !$staff && $memberinfo ne "$display_txt{'470a'}" && $memberinfo ne "$display_txt{'28'}") {
                  if (!$ignoreuser) {
                        $message = $postmessage;                  
                        $template_ignore = qq~<a href="$scripturl?action=ignore;user=$useraccount{$musername};num=$viewnum;post=$counter" onclick="return confirm('$igntxt{'2'}');">$img{'ignore'}</a>~;
                  } else {
                        $message = $ignoretxt;
                        $template_ignore = qq~<a href="$scripturl?action=unignore;user=$useraccount{$musername};num=$viewnum;post=$counter" onclick="return confirm('$igntxt{'3'}');">$img{'unignore'}</a>~;
                        $sendm = '';
                  }
            } else {
                  $message = $postmessage;
            }
</replace>

<search for>
		if ($mstate !~ /l/i) {
			unless (($enable_guestposting == 0 && $iamguest) || &AccessCheck($currentboard, 2) ne "granted" || ($annboard eq $currentboard && !$iamadmin && !$iamgmod)) {
</search for>

<replace>
		$template_quote = '';
		if ($mstate !~ /l/i) {
			unless (($enable_guestposting == 0 && $iamguest) || &AccessCheck($currentboard, 2) ne "granted" || ($annboard eq $currentboard && !$iamadmin && !$iamgmod) || $ignoreuser) {
</replace>

<search for>
		$outblock =~ s/<yabb stars>/$star/g;
</search for>

<add after>
		$outblock =~ s/<yabb ignore>/$template_ignore/g;
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
			if (!$nestedquotes) {
</search for>

<add before>
			if ($myignorecnt > 0) { $nestedquotes = 0; }
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	if ($maxrecentdisplay > 0) {
</search for>

<replace>
	$ignoreuser = '';
	if ($myignorecnt > 0) {
	      foreach (@myignorelist) {
	            chomp($_);
	            if ($user eq $_ ) { $ignoreuser = 1; last; }
	      }
	}

	if ($maxrecentdisplay > 0 && !$ignoreuser) {
</replace>

<search for>
	if ($curuser =~ m~\\~) { &fatal_error($profile_txt{'225'}); }
</search for>

<add after>
      if ($myignorecnt > 0) {
	      foreach (@myignorelist) {
      	            chomp($_);
      	            if ($curuser eq $_ ) {
      	                  $yymain .= qq~
      	                  <p align=left><a href="$scripturl?action=viewprofile;username=$useraccount{$curuser}"><b>$profile_txt{'92'} ${$uid.$curuser}{'realname'}</b></a></p>
      	                  ~;
      	                  $yytitle = "$profile_txt{'92'} ${$uid.$curuser}{'realname'}";
      	                  &template;
      	                  exit;
      	            }
      	      }
      	}
</add after>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
		$message = &Censor($message);
		$msub    = &Censor($msub);

		&wrap;
</search for>

<replace>
		if ($myignorecnt > 0) {
		      foreach (@myignorelist) {
		             chomp($_);
		             if ($musername eq $_ ) { $message = $ignoretxt; last; }
		       }
		}

		$message = &Censor($message);
		$msub    = &Censor($msub);
 
		&wrap;
</replace>

<search for>
		$message = &Censor($message);
		$msub    = &Censor($msub);
		&wrap;
</search for>

<add after>
		if ($myignorecnt > 0) {
		       foreach (@myignorelist) {
		             chomp($_);
		             if ($musername eq $_ ) { $message = $ignoretxt; last; }
		       }
		}
</add after>

<search for>
		if ($message) {
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/, $message);
			$messages[$numfound] = "$curboard|$tnum|$treplies|$msub|$mname|$mdate|$musername";
</search for>

<replace>
		if ($message) {
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/, $message);
			$ignoreuser = '';
		            if ($myignorecnt > 0) {
			           foreach (@myignorelist) {
		                       chomp($_);
		                       if ($musername eq $_ ) { $ignoreuser = 1; last; }
		                  }
			}
			if ($ignoreuser) { next; }
			$messages[$numfound] = "$curboard|$tnum|$treplies|$msub|$mname|$mdate|$musername";
</replace>

<edit file>
Sources/Search.pl
</edit file>

<search for>
				if ($searchsubject) {
</search for>

<add before>
				if ($myignorecnt > 0) {
				      foreach (@myignorelist) {
				            chomp($_);
				            if ($musername eq $_ ) { next postcheck; }
				      }
                        }
</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'hide',"SetStatus.pl&SetStatus",
</search for>

<add after>
'ignore',"IgnoreUser.pl&Ignore",
'unignore',"IgnoreUser.pl&UnIgnore",
</add after>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
	$qmessage = &parseimgflash($qmessage);
</search for>

<add before>
      	if ($myignorecnt > 0) {
      	      foreach (@myignorelist) {
      	      chomp($_);
      	      if ($qauthor eq $_ ) { $qmessage = $ignoretxt; last; }
      	      }
	}
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
		<yabb postinfo>
</search for>

<add before>
		<yabb ignore><br />
</add before>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'home' => "<img src=\"$imagesdir/home.$imgext\" alt=\"$img_txt{'103'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'103'}</span>",
</search for>

<add after>
'ignore' => "<img src=\"$imagesdir/ignore.$imgext\" alt=\"$img_txt{'ignore'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'ignore'}</span>",
'unignore' => "<img src=\"$imagesdir/unignore.$imgext\" alt=\"$img_txt{'unignore'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'unignore'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'home' => "<span class=\"imgmenu\">$img_txt{'103'}</span>",
</search for>

<add after>
'ignore' => "<span class=\"imgwindowbg\">$img_txt{'ignore'}</span>",
'unignore' => "<span class=\"imgwindowbg\">$img_txt{'unignore'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'home' => "<img src=\"$html_root/Buttons/$language/home.$imgext\" alt=\"$img_txt{'103'}\" border=\"0\" />",
</search for>

<add after>
'ignore' => "<img src=\"$html_root/Buttons/$language/ignore.$imgext\" alt=\"$img_txt{'ignore'}\" border=\"0\" />",
'unignore' => "<img src=\"$html_root/Buttons/$language/unignore.$imgext\" alt=\"$img_txt{'unignore'}\" border=\"0\" />",
</add after>